(
--------------------------------------------------------------------------
--DIMaster v2.0 
--Functions Structure
--Last Edited: 2008/02/05
--Code by Borislav "Bobo" Petrov
--http://www.scriptspot.com/bobo 
--	"modified by Kostadin Kotev // miau_u@yahoo.com// http://miauumaxscript.blogspot.bg/"  september 2016
--	"delete all objects including the point helpers"
--	"apply the color of the materials"
--------------------------------------------------------------------------

global DIMasterFunctions
struct DIMasterFunctions
(
	fn DeleteCallback theNode =
	(
		--with undo "Delete DIMaster Object" on
		(
			--callbacks.removeScripts #nodePreDelete id:#DIMaster 
			if isValidNode theNode do
			(
				if matchPattern ((classof theNode) as string) pattern:"DIM*" then
				(
					filteredNameStr = filterstring theNode.name "_"
					mainDIMObjectName = filteredNameStr[1] + "_" + filteredNameStr[2] + "_" + filteredNameStr[3]
					--	"collect all objects for this DIM measurement and delete it"
-- 					DIMobjectsArr = for o in objects where (matchPattern o.name pattern:(theNode.name + "*")) collect o
					DIMobjectsArr = for o in objects where (matchPattern o.name pattern:(mainDIMObjectName + "*")) collect o
					--	"tripple delete"
					for o in DIMobjectsArr do
					(
						try(delete o)catch()
					)
					try(delete DIMobjectsArr)catch()
						
					try(delete theNode.textNode)catch()
					try(delete theNode.node01)catch()
					try(delete theNode.node02)catch()
					try(delete theNode.node03)catch()
					try(delete theNode)catch()
				)	
				else
				(
					if (getUserProp theNode "DIMaster") == true do				
					(
						--	"collect all objects for this DIM measurement and delete it"
						filteredNameStr = filterstring theNode.name "_"
						mainDIMObjectName = filteredNameStr[1] + "_" + filteredNameStr[2] + "_" + filteredNameStr[3]
						--	"collect all objects for this DIM measurement and delete it"
-- 						DIMobjectsArr = for o in objects where (matchPattern o.name pattern:(theNode.name + "*")) collect o
						DIMobjectsArr = for o in objects where (matchPattern o.name pattern:(mainDIMObjectName + "*")) collect o
						--	"tripple delete"
						for o in DIMobjectsArr do
						(
							try(delete o)catch()
						)
						try(delete DIMobjectsArr)catch()
						
						if isValidNode theNode do
						(
							try
							(
								for o in refs.dependents theNode where isValidNode o and matchPattern ((classof o) as string) pattern:"DIM*"  do 
								(
									if  o != undefined do 
									(
										try(delete o.textNode)catch()
										try(delete o.node01)catch()
										try(delete o.node02)catch()
										try(delete o.node03)catch()
										try(delete o)catch()
									)	
								)
							)catch()
						)
					)	
				)	
			)	
			--	"updates the viewport on each deleted object. Refresh in the macroscript."
-- 			redrawViews()
			--callbacks.addScript #nodePreDelete "DIMasterFunctions.DeleteCallback (callbacks.notificationParam() )" id:#DIMaster 
		)	
	),
	fn loadSettingsFromPreset theBaseObj theFile theObj: = 
	(
		theKeys = getIniSetting theFile "Settings"
		theProps = getPropNames theBaseObj
		for k in theKeys where findItem theProps (k as name) > 0 do
		(	
			if classof (getProperty theBaseObj k) == String then
				try(setProperty theBaseObj k ((getIniSetting theFile "Settings" k)))catch(format "Failed To Set %\n" k )
			else
			(
				try(setProperty theBaseObj k (execute (getIniSetting theFile "Settings" k)))catch(format "Failed To Set %\n" k )
				--	"change the material's diffuse color"
				if k == "diffuseColor" do
				(
					try
					(
						theObj.material.diffuse = (execute (getIniSetting theFile "Settings" k)) 
					)
					catch(print "Failed to set the Mat color")
				)
				--	"change the text's diffuse color"
				if k == "textDiffColor" do
				(
					try
					(
						theObj.textNode.material.diffuse = (execute (getIniSetting theFile "Settings" k)) 
					)
					catch(print "Failed to set the Txt color")
				)
			)	
		)
		redrawViews()
	),
	fn loadSettingsFromPreferences theBaseObj theRealObj: =
	(
		theIniPath = "C:\\3dsMax_DIMaster\\"
-- 		theIniPath = ((pathConfig.GetDir (#scripts)) + "\\DIMaster" )
		thePref = getIniSetting (theIniPath + "\\DIMasterSettings.ini") "Preferences"  "Current" 
		thePrefFile = (theIniPath + "\\" + thePref + ".DIMpref") 
		theClass = (classof theBaseObj) as string
		if doesFileExist thePrefFile then
		(
			theFile = (theIniPath + "\\" + (getIniSetting thePrefFile theClass  "PreferenceFile" ) + "." + theClass )
			if doesFileExist theFile do
			(
				DIMasterFunctions.loadSettingsFromPreset theBaseObj theFile theObj:theRealObj
			)
		)
	)
)

--callbacks.removeScripts id:#DIMaster 
--DISABLED BECAUSE OF CRASHES IN UNDO SYSTEM
--callbacks.addScript #nodePreDelete "DIMasterFunctions.DeleteCallback (callbacks.notificationParam() )" id:#DIMaster 

)